Revit开发 - 几何信息(GeometryElement)的获取

    本文演示如何获取Revit文件中墙和柱各个面的面积。

1.用Revit绘制模型

    

2.获取墙各个面的面积

using Autodesk.Revit.Attributes;
using Autodesk.Revit.DB;
using Autodesk.Revit.UI;
using System.Windows.Forms;

namespace RevitAddin4
{
    [TransactionAttribute(TransactionMode.Manual)]
    public class RevitAddin : IExternalCommand
    {
        public Result Execute(ExternalCommandData commandData, ref string message, ElementSet elements)
        {
            UIDocument uiDoc = commandData.Application.ActiveUIDocument;
            Document doc = uiDoc.Document;
            FilteredElementCollector collector = new FilteredElementCollector(doc);
            var walls = collector.OfClass(typeof(Wall));

            string info = "";
            foreach (var item in walls)
            {
                Options options = new Options();
                GeometryElement geometry = item.get_Geometry(options);
                int i = 0;
                foreach (GeometryObject obj in geometry)
                {
                    Solid solid = obj as Solid;
                    if (solid != null)
                    {
                        FaceArray faceArray = solid.Faces;
                        foreach (Face face in faceArray)
                        {
                            info += "Face"+ i +" 的面积: " + face.Area.ToString() + "\n";
                            i++;
                        }
                    }
                }
            }

            MessageBox.Show(info, "信息");
            return Result.Succeeded;
        }
    }
}

    执行结果:

 

3.获取柱各个面的面积

using Autodesk.Revit.Attributes;
using Autodesk.Revit.DB;
using Autodesk.Revit.UI;
using System.Windows.Forms;

namespace RevitAddin4
{
    [TransactionAttribute(TransactionMode.Manual)]
    public class RevitAddin : IExternalCommand
    {
        public Result Execute(ExternalCommandData commandData, ref string message, ElementSet elements)
        {
            UIDocument uiDoc = commandData.Application.ActiveUIDocument;
            Document doc = uiDoc.Document;
            FilteredElementCollector collector = new FilteredElementCollector(doc);
            var columns = collector.OfClass(typeof(FamilyInstance));

            string info = "";
            foreach (var item in columns)
            {
                info += "名称: " + item.ToString() + "\n";
                Options options = new Options();
                GeometryElement geometry = item.get_Geometry(options);
                int i = 0;
                foreach (GeometryObject obj in geometry)
                {
                    GeometryInstance instance = obj as GeometryInstance;
                    if (instance == null)
                        continue;
                    GeometryElement geometryElement = instance.GetInstanceGeometry();
                    if (geometryElement == null)
                        continue;
                    foreach (GeometryObject elem in geometryElement)
                    {
                        Solid solid = elem as Solid;
                        if (solid == null || solid.Volume.ToString() == "0")
                            continue;
                        FaceArray faceArray = solid.Faces;
                        foreach (Face face in faceArray)
                        {
                            info += "Face" + i + " 的面积: " + face.Area.ToString() + "\n";
                            i++;
                        }
                    }
                }
            }
            MessageBox.Show(info, "信息");
            return Result.Succeeded;
        }
    }
}

执行结果:

 

 

  • 5
    点赞
  • 28
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值